\ float 97.11.25 4:34 pm NAB
decimal
: Fplinit ( -- 0|err)
  41183 systrap d0 drop ;
: FplFree ( --)  41184 systrap ;

: cstring. ( addr-cstring --)
  dup  >abs
  \ StrLen ( cstring-daddr -- length)
  41159 systrap  2drop  d0 drop
  type ;

: floats ( n1 -- n2)  8 chars * ; inline

: float+ ( r-addr1 -- r-addr2)
  [ 1 floats ] literal + ;

: faligned ( addr -- r-addr)
  aligned ; inline

: falign ( --)  align ; inline

\ Floating point stack:
falign  8 floats allot
here constant fp0
variable fp \ float stack pointer

: fdrop ( F: r --)
  [ 1 floats ] literal fp +! ; inline

: fpdecr ( F: -- r)
  [ -1 floats ] literal fp +! ; inline

: fdup ( F: r1 -- r1 r1)
  fp @ fpdecr fp @
  [ 1 floats ] literal move ; inline

: fdepth ( -- +n)
  fp0 fp @ -  [ 1 floats ] literal / ;

fp0 fp ! \ Init fp stack

: >fp ( -- r) ( F: -- r)
  fpdecr  fp @ 2!  fp @
  [ 2 cells ] literal + 2! ;

: fp> ( F: r --) ( -- r)
  fp @ 1+ fp0 >
    abort" fp stack underflow"
  fp @ [ 2 cells ] literal +  2@
  fp @ 2@  fdrop ;

: f@ ( r-addr --) ( F: -- r)
  fpdecr  fp @
  [ 1 floats ] literal move ;

: f! ( F: r -- ) ( r-addr --)
  >r  fp> r@ 2!
  r> [ 2 cells ] literal +  2! ;

: fvariable ( "<spaces>name" --)
  create  [ 1 floats ] literal  allot ;

: fconstant
( F: r --) ( "<spaces>name" --)
  create  here f! [ 1 floats ] literal allot
  does> ( F: -- r)  f@ ;

: fs. ( --) ( F: r --)
  here  dup >abs fp>
  \ FplFToA ( c-daddr r --)
  41185 systrap  2drop  2drop 2drop
  cstring.  space ;

: d>f ( d --) ( F: -- r)
  fpdecr fp @ >abs
  \ FplLongToFloat ( d r-daddr --)
  41188 systrap  2drop  2drop ;

: f>d ( F: r --) ( -- d)
  fp>
  \ FplFloatToLong ( r -- d)
  41189 systrap  2drop 2drop  d0 ;

variable fpsign  variable fpexp
create fpmant  2 cells allot
: fpdissect 
( F: r --) ( -- sign exp udmantissa)
  fpsign >abs  fpexp >abs
  fpmant >abs  fp> 
  \ FplBase10Info
  ( sign-da exp-da mant-uda r --)
  41187 systrap
  2drop 2drop  2drop  2drop  2drop
  fpsign @  fpexp @  fpmant 2@ ;

: fswap ( F: r1 r2 -- r2 r1)
  fp @ >r fp> r> f!  >fp  fpdecr ;

\ Factors for dyadic fp words:
: 2args
 ( F: r1 r2 --) ( -- r2 r1 r3-daddr)
  fp> fp>  fpdecr fp @ >abs ; inline

: fdyadic ( r1 r2 r3-daddr trap# --)
  systrap
  2drop  2drop 2drop  2drop 2drop ;
inline

\ Dyadic words: ( F: r1 r2 -- r3)
: f*  2args  41191 fdyadic ( FplMul) ;
: f+  2args  41192 fdyadic ( FplAdd) ;
: f-  2args  41193 fdyadic ( FplSub) ;
: f/  2args   41194 fdyadic ( FplDiv) ;

: >float
( c-addr u -- c-addr u 0 | -1) ( F: -- r)
  dup 0= if  0 exit  then
  over c@ [char] 9 > if  0 exit  then
  here  over +  0 swap c!
  here swap move
  \ FplAToF ( c-daddr r-daddr --)
  here >abs  fpdecr fp @ >abs
  41186 systrap  2drop 2drop  -1 ;

: fliteral ( F: r --)  fp> 2swap
  postpone 2literal  postpone 2literal
  postpone >fp ; immediate

: parsefloat
  >float  dup state @ and
  if  postpone fliteral  then ;

' parsefloat parsevector !

: FloatAbort ( --)
  Fplinit drop  fp0 fp !
  [ abortvector @ ] literal execute ;

' FloatAbort abortvector !

: f< ( F: r1 r2 --) ( -- bool)
  f-  fpdissect 2drop drop  0< ;

: f0< ( F: r --) ( -- bool)  0e0 f< ;

: f0= ( F: r --) ( -- bool)
  fpdissect  d0=  nip nip ;

fvariable r1  fvariable r2
: fmax ( F: r1 r2 -- r1|r2)
   r1 f!  r2 f!  r1 f@  r2 f@
  f< if  r2 f@  else  r1 f@ then ;
: fmin ( F: r1 r2 -- r1|r2)
  r1 f!  r2 f!  r1 f@  r2 f@
  f< if  r1 f@  else  r2 f@  then ;

: fnegate ( F: r1 -- r2)  -1e0 f* ;

: fint ( F: r1 -- r2)  f>d d>f ; inline

: fround ( F: r1 -- r2)  0.5e0 f+  fint ;

: floor ( F: r1 -- r2)
  fdup f0<  0.5e0  if  fnegate  then
  f+  fint ;

: frot ( F: r1 r2 r3 -- r2 r3 r1)
  fp>  fswap  >fp fswap ;

: fover ( F: r1 r2 -- r1 r2 r1)
  fp>  fdup  >fp fswap ;

: represent
( F: r --) ( c-addr u -- n flag1 flag2)
  2dup  [char] 0  fill
  fpdissect  2dup d0= >r  2swap  r>
  if  1-  then  swap >r >r
  <# #s #>  dup  r> + >r
  rot min  >r swap r>  move
  r>   r> -1 =   -1 ;

Fplinit drop
